'**********************************************************
'Compiler            : BASCOM-AVR
'Hardware            : DS1820 an PD.6
'                      LC-Display
'Chip type           : AT90S2313
'**********************************************************

$regfile = "2313def.dat"                 'AT90S2313
$crystal = 3579545                       'Quarz 3.579MHz

Config 1wire = Portd.6                   'DS1820 DQ an PD6

Dim Ds1820 As Integer                    'Variablennname und Typ festlegen
Dim Halb As Byte

Lcd "DS1820 an PD.6"                     'Ausgabe des Textes auf LCD 
Wait 3                                   'warte 3 Sekunden
Cls                                      'lsche LCD
Lcd "Temp:"                              'Ausgabe des Textes auf LCD
Do                                       'Beginn Schleife
  1wreset                                'Reset DS1821
  1wwrite &HCC                           'berspringe ROM
  1wwrite &H44                           'starte Temperaturkonvertierung
  Waitms 300                             'warte 100 Millisekunden
  1wreset                                'Reset DS1821
  1wwrite &HCC                           'berspringe ROM
  1wwrite &HBE                           'sende T-Register 60h und 61h an Atmel
  Ds1820 = 1wread(9)                     'lese die empfangenen Daten
  1wreset                                'Reset DS1821
  Halb = Ds1820 And 1                    'prfen auf letztes Bit (x.5 Grad)
  Locate 2 , 1                           'LCD-Cursor auf Zeile2, Spalte1
  Shift Ds1820, Right                    'entferne letztes Bit (Rechtsschieben)
  If Ds1820 > 127 Then                   'wenn Temperatur negativ ist
    Lcd "-"                              'dann "Minus" auf LCD ausgeben
    Ds1820 = 256 - Ds1820                'und negative Temperatur berechnen
    If Halb = 1 Then Ds1820 = Ds1820 - 1 'wenn Wert x.5 dann um 1 korrigieren
  Else                                   'wenn Temperatur Positiv
    Lcd " "                              'dann Leerzeichen auf Display ausgeben
  End If
  Lcd Ds1820 ; ".";                      'Ausgabe Temperatur und Komma
  If Halb = 1 Then                       'wenn x.5
    Lcd "5"                              'dann "5" nach Komma ausgeben 
  Else                                   'wenn x.0
    Lcd "0"                              'sonst "0" nach Komma ausgeben
  End If
  Lcd "C "                               'Ausgabe des Textes auf LCD
  Wait 1                                 'warte 1 Sekunde
Loop                                     'zum Beginn der Schleife 

End
